import Globals
from OFS import SimpleItem, ObjectManager, PropertyManager, FindSupport
import AccessControl.Role, webdav.Collection
from webdav.WriteLockInterface import WriteLockInterface
from AccessControl import Unauthorized
from Globals import HTMLFile
from Globals import DTMLFile
from AccessControl import getSecurityManager
from Globals import Persistent
import Acquisition
from Globals import MessageDialog
import string



from Globals import Persistent, DTMLFile
from Acquisition import Implicit
from OFS.SimpleItem import Item
from AccessControl import getSecurityManager
import Globals


class ZtimeEntry(Item, Persistent, Implicit):
	"Creates Timesheet entries"
	meta_type = "Timesheet Entry"
	statusNames=['Open', 'Pending', 'Approved']
	def __init__(self,id,USER_ID,PROJECT_NAME,hours_date, comments,year, week, dow,total_hours, status):
		self.id=id
		 
		self.editZtimeEntry(USER_ID,PROJECT_NAME,hours_date,comments,year,week,dow,total_hours,status)
	def editZtimeEntry(self,USER_ID,PROJECT_NAME,hours_date,comments,year,week,dow,total_hours,status,REQUEST=None
		):
 		"Method for updating timesheet entries"
		self.USER_ID=USER_ID
		self.PROJECT_NAME=PROJECT_NAME
 		self.hours_date=hours_date
		self.comments=comments
		self.year=year
		self.week=week
		self.dow=dow
		self.total_hours=total_hours
		self.status=status
		if REQUEST is not None:
			return self.editWeekForm(self,REQUEST)
	def getStatusName(self):
		"""bleh tager variablen status som indexeringsparameter"""
		return self.statusNames[self.status] 


#Web Presentation Methods
	editZtimeEntryForm=DTMLFile("dtml/editZtimeEntryForm",globals())
	index_html=DTMLFile("dtml/ZtimeentryDetails",globals())

class ZtimeEntryDemo(Item, Persistent, Implicit):
	"Timesheet entry"
	meta_type = "Timesheet Entry"
	statusNames=['Open', 'Pending', 'Approved']
	def __init__(self,sqlResults):
		self.total_hours=0
		self.status=len(self.statusNames)
		self.days=[]
		
		for i in range(7):
			self.days.append(0)
		for d in sqlResults:
			status=d.status
			if status<self.status:
				self.status=status
			dow=d.dow
			th=d.total_hours
			self.days[dow]=self.days[dow]+th
			self.total_hours=self.total_hours+th
			try:
				#self.category_id=sqlattr(d,'category_id')
				self.PROJECT_NAME=d.PROJECT_NAME
			except:
				pass

	def getStatusName(self):
		"""bleh tager variablen status som indexeringsparameter"""
		return self.statusNames[self.status] 

class MemberZTimeEntry(Implicit):
	statusNames=['Open', 'Pending', 'Approved']
	def __init__(self, sqlRow):
		self.days=[]
		for i in range(7):
			self.days.append(0)
		for i in sqlRow:
			
			self.USER_ID=i.USER_ID
			self.year=i.year
			self.week=i.week
			self.status='Open'
			self.PROJECT_NAME=i.PROJECT_NAME
			self.days[i.dow]=i.total_hours
			self.total_hours=i.total_hours
			if i.dow==1:
				self.days[i.dow]=i.total_hours
				self.total_hours=self.total_hours+i.total_hours
			if i.dow==2:
				self.days[i.dow]=i.total_hours
				self.total_hours=self.total_hours+i.total_hours
			if i.dow==3:
				self.days[i.dow]=i.total_hours
				self.total_hours=self.total_hours+i.total_hours
			if i.dow==4:
				self.days[i.dow]=i.total_hours
				self.total_hours=self.total_hours+i.total_hours
			if i.dow==5:
				self.days[i.dow]=i.total_hours
				self.total_hours=self.total_hours+i.total_hours
			if i.dow==6:
				self.days[i.dow]=i.total_hours
				self.total_hours=self.total_hours+i.total_hours	
			
		
		
		#self.category_id=sqlattr(sqlRow, 'category_id')				
		
		#self.is_billable=sqlattr(sqlRow, 'billable')
		


